searchNodes=[{"doc":"Invokes webp with the given args. Usage: mix webp TASK_OPTIONS PROFILE Example: mix webp default Options --runtime-config - load the runtime configuration before executing command Note flags to control this Mix task must be given before the profile: mix webp -- runtime - config default","ref":"Mix.Tasks.Webp.html","title":"Mix.Tasks.Webp","type":"task"},{"doc":"Webp is a installer and runner for [Webp]. Profiles You can define multiple configuration profiles. By default, there is a profile called :default which you can configure its args, current directory and environment: config :webp , default : [ location : Path . expand ( &quot;../priv/static/images/&quot; , __DIR__ ) , destination : Path . expand ( &quot;../priv/static/images/&quot; , __DIR__ ) ] Webp configuration There are two global configurations for the webp application: :path - the path to the webp executable. Once you find the location of the executable, you can store it in a MIX_WEBP_PATH environment variable, which you can then read in your configuration file: config :webp , path : System . get_env ( &quot;MIX_WEBP_PATH&quot; )","ref":"Webp.html","title":"Webp","type":"module"},{"doc":"Returns the path to the executable. The executable may not be available if it was not yet installed.","ref":"Webp.html#bin_path/0","title":"Webp.bin_path/0","type":"function"},{"doc":"Returns the configuration for the given profile. Returns nil if the profile does not exist.","ref":"Webp.html#config_for!/1","title":"Webp.config_for!/1","type":"function"},{"doc":"Convert Source to Destination args .","ref":"Webp.html#convert/2","title":"Webp.convert/2","type":"function"},{"doc":"Convert Source to Destination if cwebp exists.","ref":"Webp.html#install_and_run/2","title":"Webp.install_and_run/2","type":"function"},{"doc":"Runs the given command with args . The given args will be appended to the configured args. The task output will be streamed directly to stdio. It returns the status of the underlying call.","ref":"Webp.html#run/2","title":"Webp.run/2","type":"function"},{"doc":"Mix tasks for installing and invoking webp .","ref":"readme.html","title":"ExWebp","type":"extras"},{"doc":"If you are going to build assets in production, then you add webp as a dependency on all environments but only start it in dev: def deps do [ { :webp , &quot;~&gt; 0.1&quot; , runtime : Mix . env ( ) == :dev } ] end However, if your assets are precompiled during development, then it only needs to be a dev dependency: def deps do [ { :webp , &quot;~&gt; 0.1&quot; , only : :dev } ] end","ref":"readme.html#installation","title":"ExWebp - Installation","type":"extras"},{"doc":"$ mix webp default &quot;assets/images/&quot;","ref":"readme.html#usage-there-are-2-ways-to-use-as-a-mix-task-or-as-a-library-mix-task-usage-detailed-below","title":"ExWebp - Usage: there are 2 ways to use as a mix task or as a library -- mix task usage detailed below","type":"extras"},{"doc":"The first argument to webp is the execution profile. You can define multiple execution profiles with the current directory, the OS environment, and default arguments to the webp task: config :webp , default : [ location : Path . expand ( &quot;../priv/static/images/&quot; , __DIR__ ) , destination : Path . expand ( &quot;../priv/static/images/&quot; , __DIR__ ) ] When mix webp default is invoked, the task arguments will be appended to the ones configured above.","ref":"readme.html#profiles","title":"ExWebp - Profiles","type":"extras"},{"doc":"To add webp to an application using Phoenix, you need only four steps. Note that installation requires that Phoenix watchers can accept MFArgs tuples – so you must have Phoenix &gt; v1.5.9. First add it as a dependency in your mix.exs : def deps do [ { :phoenix , &quot;~&gt; 1.6.0&quot; } , { :webp , &quot;~&gt; 0.1&quot; , runtime : Mix . env ( ) == :dev } ] end Now let's configure webp to use assets/images/ as the input file and compile CSS to the output location priv/static/assets/images/ : config :webp , default : [ location : Path . expand ( &quot;../priv/static/images/&quot; , __DIR__ ) , destination : Path . expand ( &quot;../priv/static/images/&quot; , __DIR__ ) ] Note: if you are using esbuild (the default from Phoenix v1.6), make sure you remove the import &quot;../css/app.css&quot; line at the top of assets/js/app.js so esbuild stops generating css files. Note: make sure the &quot;assets&quot; directory from priv/static is listed in the :only option for Plug.Static in your endpoint file at, for instance lib/my_app_web/endpoint.ex . For development, we want to enable watch mode. So find the watchers configuration in your config/dev.exs and add: webp : { Webp , :run , [ :default , ~w(--watch) ] } Note we are embedding source maps with absolute URLs and enabling the file system watcher. Finally, back in your mix.exs , make sure you have an assets.deploy alias for deployments [ &quot;assets.deploy&quot; : [ &quot;esbuild default --minify&quot; , &quot;webp default&quot; , &quot;phx.digest&quot; ] ]","ref":"readme.html#adding-to-phoenix","title":"ExWebp - Adding to Phoenix","type":"extras"},{"doc":"you will need to create webp styles in css and toggle then with some js, i load modernizer with webp support in the layout below is an example css .no-webp .img-class { background-image: url(&quot;../images/img.png&quot;); background-repeat: no-repeat; left: 100px; position: absolute; height: 411px; width: 745px; } .webp .img-class { background-image: url(&quot;../images/img.webp&quot;); background-repeat: no-repeat; left: 100px; position: absolute; height: 411px; width: 745px; } and the corresponding added to the layout &lt;html class=&quot;no-js&quot; lang=&quot;en&quot;&gt; &lt;script type=&quot;text/javascript&quot;&gt; document.documentElement.classList.remove(&quot;no-js&quot;); &lt;/script&gt; &lt;script type=&quot;text/javascript&quot; src=&quot;&lt;%= Routes.static_path(@conn, &quot;/js/modernizr_webp.js&quot;) %&gt;&quot;&gt;&lt;/script&gt; &lt;/html&gt;","ref":"readme.html#css-webp-support","title":"ExWebp - css webp support","type":"extras"},{"doc":"This package is based on the excellent esbuild by Wojtek Mach and José Valim.","ref":"readme.html#acknowledgements","title":"ExWebp - Acknowledgements","type":"extras"},{"doc":"Copyright (c) 2022 mithereal. webp source code is licensed under the MIT License .","ref":"readme.html#license","title":"ExWebp - License","type":"extras"}]